# -*- python -*-
import pygtk; pygtk.require("2.0")
import bonobo
import xchat
from xml.sax.saxutils import escape

__module_name__        = "xchatosd"
__module_version__     = "0.1"
__module_description__ = "Notifies you of IRC message directed to you, using OSD"

osd = bonobo.get_object("OAFIID:GNOME_OSD", "IDL:Bonobo/Application:1.0")
osd.ref() # AppClient steals one reference
osd = bonobo.AppClient(osd)

SHOW_FULL_MESSAGE = True

def osd_show(text):
    global osd
    if isinstance(text, unicode):
        song = text.encode("utf-8")
    osd.msg_send("show", (text,))

def print_cb(word, word_eol, userdata):
    sender = word[0].split("!")[0][1:]
    channel = word[2]
    mynick = xchat.get_info("nick")
    for w in word[3:]:
        if mynick in w.strip(":"):
            break
    else:
        return xchat.EAT_NONE
    message = "<span foreground='red'>%s</span>"\
              " <span weight='bold' foreground='white'>&lt;</span>"\
              "%s<span weight='bold' foreground='white'>&gt;</span>" % \
              (escape(channel), escape(sender))
    if SHOW_FULL_MESSAGE:
        message = " ".join((message, escape(word_eol[3][1:])))
    osd_show(message)
    return xchat.EAT_NONE

xchat.hook_server("PRIVMSG", print_cb)

